Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1429)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1430)
@@ -1419,328 +529,8 @@
 
 /*
- * pj_pool_Object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pj_pool_t * pool;
-} pj_pool_Object;
-
-
-/*
- * pj_pool_Type
- */
-static PyTypeObject pj_pool_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                         /*ob_size*/
-    "py_pjsua.PJ_Pool",        /*tp_name*/
-    sizeof(pj_pool_Object),    /*tp_basicsize*/
-    0,                         /*tp_itemsize*/
-    0,                         /*tp_dealloc*/
-    0,                         /*tp_print*/
-    0,                         /*tp_getattr*/
-    0,                         /*tp_setattr*/
-    0,                         /*tp_compare*/
-    0,                         /*tp_repr*/
-    0,                         /*tp_as_number*/
-    0,                         /*tp_as_sequence*/
-    0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
-    0,                         /*tp_call*/
-    0,                         /*tp_str*/
-    0,                         /*tp_getattro*/
-    0,                         /*tp_setattro*/
-    0,                         /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,        /*tp_flags*/
-    "pj_pool_t objects",       /* tp_doc */
-
-};
-
-
-/*
- * pjsip_endpoint_Object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pjsip_endpoint * endpt;
-} pjsip_endpoint_Object;
-
-
-/*
- * pjsip_endpoint_Type
- */
-static PyTypeObject pjsip_endpoint_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                         /*ob_size*/
-    "py_pjsua.PJSIP_Endpoint", /*tp_name*/
-    sizeof(pjsip_endpoint_Object),/*tp_basicsize*/
-    0,                         /*tp_itemsize*/
-    0,                         /*tp_dealloc*/
-    0,                         /*tp_print*/
-    0,                         /*tp_getattr*/
-    0,                         /*tp_setattr*/
-    0,                         /*tp_compare*/
-    0,                         /*tp_repr*/
-    0,                         /*tp_as_number*/
-    0,                         /*tp_as_sequence*/
-    0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
-    0,                         /*tp_call*/
-    0,                         /*tp_str*/
-    0,                         /*tp_getattro*/
-    0,                         /*tp_setattro*/
-    0,                         /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,        /*tp_flags*/
-    "pjsip_endpoint objects",  /* tp_doc */
-};
-
-
-/*
- * pjmedia_endpt_Object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pjmedia_endpt * endpt;
-} pjmedia_endpt_Object;
-
-
-/*
- * pjmedia_endpt_Type
- */
-static PyTypeObject pjmedia_endpt_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                         /*ob_size*/
-    "py_pjsua.PJMedia_Endpt",  /*tp_name*/
-    sizeof(pjmedia_endpt_Object), /*tp_basicsize*/
-    0,                         /*tp_itemsize*/
-    0,                         /*tp_dealloc*/
-    0,                         /*tp_print*/
-    0,                         /*tp_getattr*/
-    0,                         /*tp_setattr*/
-    0,                         /*tp_compare*/
-    0,                         /*tp_repr*/
-    0,                         /*tp_as_number*/
-    0,                         /*tp_as_sequence*/
-    0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
-    0,                         /*tp_call*/
-    0,                         /*tp_str*/
-    0,                         /*tp_getattro*/
-    0,                         /*tp_setattro*/
-    0,                         /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,        /*tp_flags*/
-    "pjmedia_endpt objects",   /* tp_doc */
-
-};
-
-
-/*
- * pj_pool_factory_Object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pj_pool_factory * pool_fact;
-} pj_pool_factory_Object;
-
-
-
-/*
- * pj_pool_factory_Type
- */
-static PyTypeObject pj_pool_factory_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                         /*ob_size*/
-    "py_pjsua.PJ_Pool_Factory",/*tp_name*/
-    sizeof(pj_pool_factory_Object), /*tp_basicsize*/
-    0,                         /*tp_itemsize*/
-    0,                         /*tp_dealloc*/
-    0,                         /*tp_print*/
-    0,                         /*tp_getattr*/
-    0,                         /*tp_setattr*/
-    0,                         /*tp_compare*/
-    0,                         /*tp_repr*/
-    0,                         /*tp_as_number*/
-    0,                         /*tp_as_sequence*/
-    0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
-    0,                         /*tp_call*/
-    0,                         /*tp_str*/
-    0,                         /*tp_getattro*/
-    0,                         /*tp_setattro*/
-    0,                         /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,        /*tp_flags*/
-    "pj_pool_factory objects", /* tp_doc */
-
-};
-
-
-/*
- * pjsip_cred_info_Object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-	PyObject * realm;		
-    PyObject * scheme;		
-    PyObject * username;	
-    int	data_type;	
-    PyObject * data;	
-    
-} pjsip_cred_info_Object;
-
-/*
- * cred_info_dealloc
- * deletes a cred info from memory
- */
-static void pjsip_cred_info_dealloc(pjsip_cred_info_Object* self)
-{
-    Py_XDECREF(self->realm);
-    Py_XDECREF(self->scheme);
-    Py_XDECREF(self->username);
-    Py_XDECREF(self->data);
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * cred_info_new
- * constructor for cred_info object
- */
-static PyObject * pjsip_cred_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    pjsip_cred_info_Object *self;
-
-    self = (pjsip_cred_info_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->realm = PyString_FromString("");
-        if (self->realm == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->scheme = PyString_FromString("");
-        if (self->scheme == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->username = PyString_FromString("");
-        if (self->username == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->data = PyString_FromString("");
-        if (self->data == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-    }
-
-    return (PyObject *)self;
-}
-
-
-/*
- * pjsip_cred_info_members
- */
-static PyMemberDef pjsip_cred_info_members[] =
-{
-    {
-        "realm", T_OBJECT_EX,
-        offsetof(pjsip_cred_info_Object, realm), 0,
-        "Realm"
-    },
-    {
-        "scheme", T_OBJECT_EX,
-        offsetof(pjsip_cred_info_Object, scheme), 0,
-        "Scheme"
-    },
-    {
-        "username", T_OBJECT_EX,
-        offsetof(pjsip_cred_info_Object, username), 0,
-        "User name"
-    },
-    {
-        "data", T_OBJECT_EX,
-        offsetof(pjsip_cred_info_Object, data), 0,
-        "The data, which can be a plaintext password or a hashed digest. "
-    },
-    {
-        "data_type", T_INT, offsetof(pjsip_cred_info_Object, data_type), 0,
-        "Type of data"
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-/*
- * pjsip_cred_info_Type
- */
-static PyTypeObject pjsip_cred_info_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.PJSIP_Cred_Info",      /*tp_name*/
-    sizeof(pjsip_cred_info_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)pjsip_cred_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "PJSIP Cred Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    pjsip_cred_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    pjsip_cred_info_new,             /* tp_new */
-
-};
-
-/*
  * py_pjsua_thread_register
  * !added @ 061206
  */
-static PyObject *py_pjsua_thread_register(PyObject *pSelf, PyObject 
-*pArgs)
+static PyObject *py_pjsua_thread_register(PyObject *pSelf, PyObject *pArgs)
 {
 	
@@ -1756,4 +546,6 @@
 #endif
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "sO", &name, &py_desc))
     {
@@ -1788,7 +580,9 @@
                                                     PyObject *pArgs)
 {
-    logging_config_Object *obj;	
+    PyObj_pjsua_logging_config *obj;	
     pjsua_logging_config cfg;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -1797,10 +591,7 @@
     
     pjsua_logging_config_default(&cfg);
-    obj = (logging_config_Object *) logging_config_new
-		(&logging_config_Type,NULL,NULL);
-    obj->msg_logging = cfg.msg_logging;
-    obj->level = cfg.level;
-    obj->console_level = cfg.console_level;
-    obj->decor = cfg.decor;
+    obj = (PyObj_pjsua_logging_config *) PyObj_pjsua_logging_config_new
+		(&PyTyp_pjsua_logging_config,NULL,NULL);
+    PyObj_pjsua_logging_config_import(obj, &cfg);
     
     return (PyObject *)obj;
@@ -1814,7 +605,9 @@
 static PyObject *py_pjsua_config_default(PyObject *pSelf, PyObject *pArgs)
 {
-    config_Object *obj;
+    PyObj_pjsua_config *obj;
     pjsua_config cfg;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -1822,7 +615,7 @@
     }
     pjsua_config_default(&cfg);
-    obj = (config_Object *) config_new(&config_Type, NULL, NULL);
-    obj->max_calls = cfg.max_calls;
-    obj->thread_cnt = cfg.thread_cnt;
+    obj = (PyObj_pjsua_config *) PyObj_pjsua_config_new(&PyTyp_pjsua_config, NULL, NULL);
+    PyObj_pjsua_config_import(obj, &cfg);
+
     return (PyObject *)obj;
 }
@@ -1836,6 +629,9 @@
                                                 PyObject *pArgs)
 {
-    media_config_Object *obj;
+    PyObj_pjsua_media_config *obj;
     pjsua_media_config cfg;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -1843,18 +639,7 @@
     }
     pjsua_media_config_default(&cfg);
-    obj = (media_config_Object *)PyType_GenericNew
-		(&media_config_Type, NULL, NULL);
-    obj->clock_rate = cfg.clock_rate;
-    obj->ec_options = cfg.ec_options;
-    obj->ec_tail_len = cfg.ec_tail_len;
-    obj->has_ioqueue = cfg.has_ioqueue;
-    obj->ilbc_mode = cfg.ilbc_mode;
-    obj->max_media_ports = cfg.max_media_ports;
-    obj->no_vad = cfg.no_vad;
-    obj->ptime = cfg.ptime;
-    obj->quality = cfg.quality;
-    obj->rx_drop_pct = cfg.rx_drop_pct;
-    obj->thread_cnt = cfg.thread_cnt;
-    obj->tx_drop_pct = cfg.tx_drop_pct;
+    obj = (PyObj_pjsua_media_config *)
+	  PyType_GenericNew(&PyTyp_pjsua_media_config, NULL, NULL);
+    PyObj_pjsua_media_config_import(obj, &cfg);
     return (PyObject *)obj;
 }
@@ -1867,7 +652,9 @@
 static PyObject *py_pjsua_msg_data_init(PyObject *pSelf, PyObject *pArgs)
 {
-    msg_data_Object *obj;
+    PyObj_pjsua_msg_data *obj;
     pjsua_msg_data msg;
     
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -1875,5 +662,5 @@
     }
     pjsua_msg_data_init(&msg);
-    obj = (msg_data_Object *)msg_data_new(&msg_data_Type, NULL, NULL);
+    obj = (PyObj_pjsua_msg_data *)PyObj_pjsua_msg_data_new(&PyTyp_pjsua_msg_data, NULL, NULL);
     Py_XDECREF(obj->content_type);
     obj->content_type = PyString_FromStringAndSize(
@@ -1897,8 +684,10 @@
 {
     PyObject * logObj;
-    logging_config_Object *log;
+    PyObj_pjsua_logging_config *log;
     pjsua_logging_config cfg;
     pj_status_t status;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "O", &logObj))
     {
@@ -1907,5 +696,5 @@
     if (logObj != Py_None) 
     {
-        log = (logging_config_Object *)logObj;
+        log = (PyObj_pjsua_logging_config *)logObj;
         cfg.msg_logging = log->msg_logging;
         cfg.level = log->level;
@@ -1935,5 +724,7 @@
     const char * name;
     pj_pool_t *p;
-    pj_pool_Object *pool;
+    PyObj_pj_pool *pool;
+
+    PJ_UNUSED_ARG(pSelf);
 
     if (!PyArg_ParseTuple(pArgs, "sII", &name, &init_size, &increment))
@@ -1943,5 +734,5 @@
     
     p = pjsua_pool_create(name, init_size, increment);
-    pool = (pj_pool_Object *)PyType_GenericNew(&pj_pool_Type, NULL, NULL);
+    pool = (PyObj_pj_pool *)PyType_GenericNew(&PyTyp_pj_pool_t, NULL, NULL);
     pool->pool = p;
     return (PyObject *)pool;
@@ -1955,7 +746,9 @@
 static PyObject *py_pjsua_get_pjsip_endpt(PyObject *pSelf, PyObject *pArgs)
 {
-    pjsip_endpoint_Object *endpt;
+    PyObj_pjsip_endpoint *endpt;
     pjsip_endpoint *e;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -1963,6 +756,6 @@
     }
     e = pjsua_get_pjsip_endpt();
-    endpt = (pjsip_endpoint_Object *)PyType_GenericNew(
-        &pjsip_endpoint_Type, NULL, NULL
+    endpt = (PyObj_pjsip_endpoint *)PyType_GenericNew(
+        &PyTyp_pjsip_endpoint, NULL, NULL
     );
     endpt->endpt = e;
@@ -1976,7 +769,9 @@
 static PyObject *py_pjsua_get_pjmedia_endpt(PyObject *pSelf, PyObject *pArgs)
 {
-    pjmedia_endpt_Object *endpt;
+    PyObj_pjmedia_endpt *endpt;
     pjmedia_endpt *e;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -1984,6 +779,6 @@
     }
     e = pjsua_get_pjmedia_endpt();
-    endpt = (pjmedia_endpt_Object *)PyType_GenericNew(
-        &pjmedia_endpt_Type, NULL, NULL
+    endpt = (PyObj_pjmedia_endpt *)PyType_GenericNew(
+        &PyTyp_pjmedia_endpt, NULL, NULL
     );
     endpt->endpt = e;
@@ -1997,7 +792,9 @@
 static PyObject *py_pjsua_get_pool_factory(PyObject *pSelf, PyObject *pArgs)
 {
-    pj_pool_factory_Object *pool;
+    PyObj_pj_pool_factory *pool;
     pj_pool_factory *p;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -2005,6 +802,6 @@
     }
     p = pjsua_get_pool_factory();
-    pool = (pj_pool_factory_Object *)PyType_GenericNew(
-        &pj_pool_factory_Type, NULL, NULL
+    pool = (PyObj_pj_pool_factory *)PyType_GenericNew(
+        &PyTyp_pj_pool_factory, NULL, NULL
     );
     pool->pool_fact = p;
@@ -2021,4 +818,7 @@
     const char *title;
     pj_status_t status;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "ssi", &sender, &title, &status))
     {
@@ -2038,4 +838,7 @@
 {
     pj_status_t status;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -2061,23 +864,15 @@
 {
     pj_status_t status;
-    PyObject * ua_cfgObj;
-    config_Object * ua_cfg;
-    PyObject * log_cfgObj;
-    logging_config_Object * log_cfg;
-    PyObject * media_cfgObj;
-    media_config_Object * media_cfg;
-    pjsua_config cfg_ua;
-    pjsua_config * p_cfg_ua;
-    pjsua_logging_config cfg_log;
-    pjsua_logging_config * p_cfg_log;
-    pjsua_media_config cfg_media;
-    pjsua_media_config * p_cfg_media;
-    unsigned i;
-
-    if (!PyArg_ParseTuple(pArgs, "OOO", &ua_cfgObj, &log_cfgObj,&media_cfgObj))
-    {
-        return NULL;
-    }
-
+    PyObject *o_ua_cfg, *o_log_cfg, *o_media_cfg;
+    pjsua_config cfg_ua, *p_cfg_ua;
+    pjsua_logging_config cfg_log, *p_cfg_log;
+    pjsua_media_config cfg_media, *p_cfg_media;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "OOO", &o_ua_cfg, &o_log_cfg, &o_media_cfg))
+    {
+        return NULL;
+    }
     
     pjsua_config_default(&cfg_ua);
@@ -2085,19 +880,11 @@
     pjsua_media_config_default(&cfg_media);
 
-    if (ua_cfgObj != Py_None) 
-    {
-	ua_cfg = (config_Object *)ua_cfgObj;
-        cfg_ua.cred_count = ua_cfg->cred_count;
-        for (i = 0; i < 4; i++)
-	{
-            cfg_ua.cred_info[i] = ua_cfg->cred_info[i];
-	}
-        cfg_ua.max_calls = ua_cfg->max_calls;
-        for (i = 0; i < PJSUA_ACC_MAX_PROXIES; i++)
-	{
-            cfg_ua.outbound_proxy[i] = ua_cfg->outbound_proxy[i];
-	}
-
-    	g_obj_callback = ua_cfg->cb;
+    if (o_ua_cfg != Py_None) 
+    {
+	PyObj_pjsua_config *obj_ua_cfg = (PyObj_pjsua_config*)o_ua_cfg;
+
+	PyObj_pjsua_config_export(&cfg_ua, obj_ua_cfg);
+
+    	g_obj_callback = obj_ua_cfg->cb;
     	Py_INCREF(g_obj_callback);
 
@@ -2105,4 +892,5 @@
     	cfg_ua.cb.on_incoming_call = &cb_on_incoming_call;
     	cfg_ua.cb.on_call_media_state = &cb_on_call_media_state;
+	cfg_ua.cb.on_dtmf_digit = &cb_on_dtmf_digit;
     	cfg_ua.cb.on_call_transfer_request = &cb_on_call_transfer_request;
     	cfg_ua.cb.on_call_transfer_status = &cb_on_call_transfer_status;
@@ -2115,48 +903,35 @@
     	cfg_ua.cb.on_typing = &cb_on_typing;
 
-        cfg_ua.outbound_proxy_cnt = ua_cfg->outbound_proxy_cnt;
-        cfg_ua.thread_cnt = ua_cfg->thread_cnt;
-        cfg_ua.user_agent.ptr = PyString_AsString(ua_cfg->user_agent);
-        cfg_ua.user_agent.slen = strlen(cfg_ua.user_agent.ptr);
-
         p_cfg_ua = &cfg_ua;
+
     } else {
         p_cfg_ua = NULL;
     }
 
-    if (log_cfgObj != Py_None) 
-    {
-        log_cfg = (logging_config_Object *)log_cfgObj;
-        cfg_log.msg_logging = log_cfg->msg_logging;
-        cfg_log.level = log_cfg->level;
-        cfg_log.console_level = log_cfg->console_level;
-        cfg_log.decor = log_cfg->decor;
-        cfg_log.log_filename.ptr = PyString_AsString(log_cfg->log_filename);
-        cfg_log.log_filename.slen = strlen(cfg_log.log_filename.ptr);
+    if (o_log_cfg != Py_None) 
+    {
+	PyObj_pjsua_logging_config * obj_log;
+
+        obj_log = (PyObj_pjsua_logging_config *)o_log_cfg;
+        
+        PyObj_pjsua_logging_config_export(&cfg_log, obj_log);
+
         Py_XDECREF(obj_log_cb);
-        obj_log_cb = log_cfg->cb;
+        obj_log_cb = obj_log->cb;
         Py_INCREF(obj_log_cb);
+
         cfg_log.cb = &cb_log_cb;
         p_cfg_log = &cfg_log;
+
     } else {
         p_cfg_log = NULL;
     }
 
-    if (media_cfgObj != Py_None) 
-    {
-        media_cfg = (media_config_Object *)media_cfgObj;
-        cfg_media.clock_rate = media_cfg->clock_rate;
-        cfg_media.ec_options = media_cfg->ec_options;
-        cfg_media.ec_tail_len = media_cfg->ec_tail_len;
-        cfg_media.has_ioqueue = media_cfg->has_ioqueue;
-        cfg_media.ilbc_mode = media_cfg->ilbc_mode;
-        cfg_media.max_media_ports = media_cfg->max_media_ports;
-        cfg_media.no_vad = media_cfg->no_vad;
-        cfg_media.ptime = media_cfg->ptime;
-        cfg_media.quality = media_cfg->quality;
-        cfg_media.rx_drop_pct = media_cfg->rx_drop_pct;
-        cfg_media.thread_cnt = media_cfg->thread_cnt;
-        cfg_media.tx_drop_pct = media_cfg->tx_drop_pct;
-	    p_cfg_media = &cfg_media;
+    if (o_media_cfg != Py_None) 
+    {
+	PyObj_pjsua_media_config_export(&cfg_media, 
+				        (PyObj_pjsua_media_config*)o_media_cfg);
+	p_cfg_media = &cfg_media;
+
     } else {
         p_cfg_media = NULL;
@@ -2174,4 +949,7 @@
 {
     pj_status_t status;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -2190,4 +968,7 @@
 {
     pj_status_t status;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -2207,4 +988,7 @@
     int ret;
     unsigned msec;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "i", &msec))
     {
@@ -2232,4 +1016,7 @@
     pj_status_t status;
     const char *url;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "s", &url))
     {
@@ -2264,10 +1051,10 @@
 
 static char pjsua_init_doc[] =
-    "int py_pjsua.init (py_pjsua.Config ua_cfg, "
+    "int py_pjsua.init (py_pjsua.Config obj_ua_cfg, "
         "py_pjsua.Logging_Config log_cfg, py_pjsua.Media_Config media_cfg) "
     "Initialize pjsua with the specified settings. All the settings are "
     "optional, and the default values will be used when the config is not "
     "specified. Parameters: "
-    "ua_cfg : User agent configuration;  "
+    "obj_ua_cfg : User agent configuration;  "
     "log_cfg : Optional logging configuration; "
     "media_cfg : Optional media configuration.";
@@ -2300,5 +1087,5 @@
 
 static char pjsua_pool_create_doc[] =
-    "py_pjsua.PJ_Pool py_pjsua.pool_create (string name, int init_size, "
+    "py_pjsua.Pj_Pool py_pjsua.pool_create (string name, int init_size, "
                                             "int increment) "
     "Create memory pool Parameters: "
@@ -2308,5 +1095,5 @@
 
 static char pjsua_get_pjsip_endpt_doc[] =
-    "py_pjsua.PJSIP_Endpoint py_pjsua.get_pjsip_endpt (void) "
+    "py_pjsua.Pjsip_Endpoint py_pjsua.get_pjsip_endpt (void) "
     "Internal function to get SIP endpoint instance of pjsua, which is needed "
     "for example to register module, create transports, etc. Probably is only "
@@ -2314,10 +1101,10 @@
 
 static char pjsua_get_pjmedia_endpt_doc[] =
-    "py_pjsua.PJMedia_Endpt py_pjsua.get_pjmedia_endpt (void) "
+    "py_pjsua.Pjmedia_Endpt py_pjsua.get_pjmedia_endpt (void) "
     "Internal function to get media endpoint instance. Only valid after "
     "pjsua_init() is called.";
 
 static char pjsua_get_pool_factory_doc[] =
-    "py_pjsua.PJ_Pool_Factory py_pjsua.get_pool_factory (void) "
+    "py_pjsua.Pj_Pool_Factory py_pjsua.get_pool_factory (void) "
     "Internal function to get PJSUA pool factory. Only valid after "
     "pjsua_init() is called.";
